-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4517 of the CMF schema. 
-- Use Hibernate Map for Processes Parcel Map
--

update SCHEMA_VERSION set VERSION=4517;

alter table PROCESSES
  drop column PARCELS;

create table PROCESS_PARCELS (
  PROCESS_ID number constraint NN_PROCESSES_PROCESS_ID not null,
  VERSION varchar(255) constraint NN_PROCESSES_VERSION not null,
  PARCEL_NAME varchar(255) constraint NN_PROCESSES_PARCEL_NAME not null,
  primary key (PROCESS_ID, PARCEL_NAME)
);

create index IDX_PARCEL_PROCESS on PROCESS_PARCELS (PROCESS_ID);

alter table PROCESS_PARCELS
  add constraint FK_PROCESS_PARCELS_PROCESS
  foreign key (PROCESS_ID)
  references PROCESSES (PROCESS_ID)
  deferrable initially immediate;
